

#######Set-up


library(ggplot2)
library(dplyr)

library(readxl)
#library(writexl)
#library(rJava)
#library(xlsx)
#library(xlsReadWrite)
library(xts)
#library(zoo)
library(lubridate)

library(dplyr)
library(tidyr)


setwd("C:/Users/ryanell/Desktop/Macro money/R")
getwd()




#####################################################################################################
################################### Descriptive charts but with Covid period ########################
#####################################################################################################



#Import from excel (PROB NEED TO CHANGE AROUND FILE LOCATIONS)
us_mon_agg_covid <- read_excel("Data/us_mon_aggs_covid.xls", 
                         sheet = "r_input")


us_mon_agg_covid$date_m<-as.Date(us_mon_agg_covid$date)


#Add required variables to us monetary aggs data 

us_mon_agg_covid$m2_fix<- us_mon_agg_covid$M2 - us_mon_agg_covid$CURRENCY - us_mon_agg_covid$`retail money funds`

us_mon_agg_covid$money_mult <- (us_mon_agg_covid$CURRENCY + us_mon_agg_covid$m2_fix)/(us_mon_agg_covid$CURRENCY + us_mon_agg_covid$RESERVES)


us_mon_agg_covid$cd <- us_mon_agg_covid$CURRENCY/us_mon_agg_covid$m2_fix

us_mon_agg_covid$cr <- us_mon_agg_covid$CURRENCY/us_mon_agg_covid$RESERVES

us_mon_agg_covid$base_ch <- (us_mon_agg_covid$CURRENCY+us_mon_agg_covid$RESERVES) - (lag(us_mon_agg_covid$CURRENCY,1)+lag(us_mon_agg_covid$RESERVES,1))


#us_mon_agg_covid$res_ch[1]<-0
us_mon_agg_covid$base_ch[1]<-0


us_mon_agg_covid$period <- seq(1:nrow(us_mon_agg_covid))


#For dates https://www.newyorkfed.org/markets/programs-archive/large-scale-asset-purchases


lsap_dates_covid <- data.frame(start=as.Date(c("2008-12-01", "2010-11-01","2012-09-01","2017-10-01","2020-03-01")), 
                         end=as.Date(c( "2010-03-01", "2011-06-01", "2014-10-01","2019-10-01","2021-08-01")),
                         prog=c("QE1", "QE2", "QE3", "Normalisation","Covid-19"))




################################################################# Charts #################################################################


#TOTAL RESERVES CHART IN PAPER
ggplot() + geom_line(data = us_mon_agg_covid, aes(x = date_m, y = RESERVES/1000), color = "black", size = 1) + 
  xlab ("")  +  ylab ("")  + theme_bw() + scale_y_continuous(breaks=seq(0,4.5,.5), limits = c(0,4.5)) + 
  scale_x_date(breaks = as.Date(c("2004-01-01","2008-01-01",  "2012-01-01",  "2016-01-01",  "2020-01-01")), labels = c("2004","2008",  "2012",  "2016",  "2020"))  +
   theme(axis.text.x = element_text(size=20)) + theme(axis.text.y = element_text(size=20)) +
  geom_text(data=lsap_dates_covid, mapping=aes(x=end, y= 2, label=prog), size=5, angle=90, vjust=-0.4, hjust=0, color = "black") +
  geom_rect(data=lsap_dates_covid, mapping=aes(xmin=start, xmax=end, ymin=0, ymax=4.5), fill="grey", alpha=0.2) 


dev.copy(pdf,'Charts/F. Covid/res_covid_bw.pdf')

dev.off()


#TOTAL RESERVES AND MONETARY BASE CHART IN PAPER
ggplot() + geom_line(data = us_mon_agg_covid, aes(x = date_m, y = RESERVES/1000, linetype = "Total reserves"), size = 1) + 
  geom_line(data = us_mon_agg_covid, aes(x = date_m, y = (CURRENCY + RESERVES)/1000, linetype = "Monetary base"), size = 1) +
  xlab ("")  +  ylab ("")  + theme_bw() + scale_y_continuous(breaks=seq(0,6,1), limits = c(0,6)) + 
  scale_x_date(breaks = as.Date(c("2004-01-01","2008-01-01",  "2012-01-01",  "2016-01-01",  "2020-01-01")), labels = c("2004","2008",  "2012",  "2016",  "2020"))  +
  theme(axis.text.x = element_text(size=20)) + theme(axis.text.y = element_text(size=20)) +
  geom_text(data=lsap_dates_covid, mapping=aes(x=end, y= 0, label=prog), size=5, angle=90, vjust=-0.4, hjust=0, color = "black") +
  geom_rect(data=lsap_dates_covid, mapping=aes(xmin=start, xmax=end, ymin=0, ymax=6), fill="grey", alpha=0.2) +
  scale_color_brewer(palette = "Set1") + scale_fill_brewer(palette = "Set1") + theme_bw()+
  theme(text = element_text(size=20)) + theme(axis.text.x = element_text(size=20)) + theme(axis.text.y = element_text(size=20)) +
  theme(legend.title = element_blank()) + theme(legend.position="bottom") + theme(legend.text=element_text(size=20)) + guides(colour = guide_legend(nrow = 2))



dev.copy(pdf,'Charts/F. Covid/res_and_base_covid_bw.pdf')

dev.off()

#MONEY MULTIPLIER CHART IN PAPER
ggplot() + geom_line(data = us_mon_agg_covid, aes(x = date_m, y = money_mult), color = "black", size = 1) + 
  xlab ("")  +  ylab ("")  + theme_bw() + scale_y_continuous(breaks=seq(0,10,2), limits = c(0,10)) + 
  scale_x_date(breaks = as.Date(c("2004-01-01","2008-01-01",  "2012-01-01",  "2016-01-01",  "2020-01-01")), labels = c("2004","2008",  "2012",  "2016",  "2020"))  +
  theme(axis.text.x = element_text(size=20)) + theme(axis.text.y = element_text(size=20))+
  geom_text(data=lsap_dates_covid, mapping=aes(x=end, y= 7, label=prog), size=5, angle=90, vjust=-0.4, hjust=0, color = "black") +
  geom_rect(data=lsap_dates_covid, mapping=aes(xmin=start, xmax=end, ymin=0, ymax=10), fill="grey", alpha=0.2) 



ggsave("Charts/F. Covid/us_mult_covid.png")



dev.copy(pdf,'Charts/F. Covid/us_mult_covid_bw.pdf')

dev.off()


#####################################################################################################
########################### Re-run final calibrations #################################
#####################################################################################################

############################### Drop pre-QE months for analysis
us_mon_agg_covid2 <- us_mon_agg_covid[seq(56,nrow(us_mon_agg_covid)),]

us_mon_agg_covid2$period <- seq(1:nrow(us_mon_agg_covid2))

us_mon_agg_covid2$date[1]



cap_constraint <- c(0.06,0.12,0.08)

##Allow banking system to start out with a little spare capital
start_capital <- cap_constraint*(us_mon_agg_covid2$m2_fix[1]-us_mon_agg_covid2$RESERVES[1])



######### Beta = 0.85


mm_model_core_cap_iterations(num_it = 100, i_cb = us_mon_agg_covid2$base_ch, i_beta_h = 0.85, 
                             i_beta_l = 0.85,
                             i_num_banks = 100, i_sh_low_beta = 0, i_sh_seller = 0.8,i_seller_pp = 0.6,  
                             i_res_start = us_mon_agg_covid2$RESERVES[1], i_dep_start = us_mon_agg_covid2$m2_fix[1], 
                             i_curr_res= us_mon_agg_covid2$cr, i_cap_start = start_capital[1],
                             i_non_bank_sh = 0.9, i_repay = 0.01, 
                             i_cap_c = cap_constraint[1], i_nim = 0.01,
                             i_print_detail = FALSE)


us_cap_1<-key_stats
us_cap_1$date_m<-c(us_mon_agg_covid2$date_m[1],us_mon_agg_covid2$date_m)


us_cap_1_sum<- us_cap_1 %>%
  group_by(date_m) %>%
  summarize(med_mult = quantile(model_money_mult, prob = 0.5), 
            bot_mult = quantile(model_money_mult, prob = 0.01), 
            top_mult = quantile(model_money_mult, prob = 0.99),
            med_loan = quantile(total_loans, prob = 0.5), 
            bot_loan = quantile(total_loans, prob = 0.01), 
            top_loan = quantile(total_loans, prob = 0.99),
            med_push = quantile(bank_push, prob = 0.5), 
            bot_push = quantile(bank_push, prob = 0.01), 
            top_push = quantile(bank_push, prob = 0.99),
            med_dep = quantile(total_deposits, prob = 0.5), 
            bot_dep = quantile(total_deposits, prob = 0.01), 
            top_dep = quantile(total_deposits, prob = 0.99),
            med_res_unw = quantile(tot_cap_res, prob = 0.5), 
            bot_res_unw = quantile(tot_cap_res, prob = 0.01), 
            top_res_unw = quantile(tot_cap_res, prob = 0.99))


mm_model_core_cap_iterations(num_it = 100, i_cb = us_mon_agg_covid2$base_ch, i_beta_h = 0.85, 
                             i_beta_l = 0.85,
                             i_num_banks = 100, i_sh_low_beta = 0, i_sh_seller = 0.8,i_seller_pp = 0.6,  
                             i_res_start = us_mon_agg_covid2$RESERVES[1], i_dep_start = us_mon_agg_covid2$m2_fix[1], 
                             i_curr_res= us_mon_agg_covid2$cr, i_cap_start = start_capital[3],
                             i_non_bank_sh = 0.9, i_repay = 0.01, 
                             i_cap_c = cap_constraint[3], i_nim = 0.01,
                             i_print_detail = FALSE)


us_cap_3<-key_stats
us_cap_3$date_m<-c(us_mon_agg_covid2$date_m[1],us_mon_agg_covid2$date_m)


us_cap_3_sum<- us_cap_3 %>%
  group_by(date_m) %>%
  summarize(med_mult = quantile(model_money_mult, prob = 0.5), 
            bot_mult = quantile(model_money_mult, prob = 0.01), 
            top_mult = quantile(model_money_mult, prob = 0.99),
            med_loan = quantile(total_loans, prob = 0.5), 
            bot_loan = quantile(total_loans, prob = 0.01), 
            top_loan = quantile(total_loans, prob = 0.99),
            med_push = quantile(bank_push, prob = 0.5), 
            bot_push = quantile(bank_push, prob = 0.01), 
            top_push = quantile(bank_push, prob = 0.99),
            med_dep = quantile(total_deposits, prob = 0.5), 
            bot_dep = quantile(total_deposits, prob = 0.01), 
            top_dep = quantile(total_deposits, prob = 0.99),
            med_res_unw = quantile(tot_cap_res, prob = 0.5), 
            bot_res_unw = quantile(tot_cap_res, prob = 0.01), 
            top_res_unw = quantile(tot_cap_res, prob = 0.99))


mm_model_core_cap_iterations(num_it = 100, i_cb = us_mon_agg_covid2$base_ch, i_beta_h = 0.85, 
                             i_beta_l = 0.85,
                             i_num_banks = 100, i_sh_low_beta = 0, i_sh_seller = 0.8,i_seller_pp = 0.6,  
                             i_res_start = us_mon_agg_covid2$RESERVES[1], i_dep_start = us_mon_agg_covid2$m2_fix[1], 
                             i_curr_res= us_mon_agg_covid2$cr, i_cap_start = start_capital[2],
                             i_non_bank_sh = 0.9, i_repay = 0.01, 
                             i_cap_c = cap_constraint[2], i_nim = 0.01,
                             i_print_detail = FALSE)


us_cap_2<-key_stats
us_cap_2$date_m<-c(us_mon_agg_covid2$date_m[1],us_mon_agg_covid2$date_m)


us_cap_2_sum<- us_cap_2 %>%
  group_by(date_m) %>%
  summarize(med_mult = quantile(model_money_mult, prob = 0.5), 
            bot_mult = quantile(model_money_mult, prob = 0.01), 
            top_mult = quantile(model_money_mult, prob = 0.99),
            med_loan = quantile(total_loans, prob = 0.5), 
            bot_loan = quantile(total_loans, prob = 0.01), 
            top_loan = quantile(total_loans, prob = 0.99),
            med_push = quantile(bank_push, prob = 0.5), 
            bot_push = quantile(bank_push, prob = 0.01), 
            top_push = quantile(bank_push, prob = 0.99),
            med_dep = quantile(total_deposits, prob = 0.5), 
            bot_dep = quantile(total_deposits, prob = 0.01), 
            top_dep = quantile(total_deposits, prob = 0.99),
            med_res_unw = quantile(tot_cap_res, prob = 0.5), 
            bot_res_unw = quantile(tot_cap_res, prob = 0.01), 
            top_res_unw = quantile(tot_cap_res, prob = 0.99))


ggplot() + 
  geom_line(data = us_cap_1_sum,  aes(x = date_m, y = med_mult, linetype = "6% constraint"), color = "black", size = 1.2)  +
#  geom_line(data = us_cap_1_sum,  aes(x = date_m, y = top_mult, linetype = "6% constraint"), linetype="dashed")  +
#  geom_line(data = us_cap_1_sum,  aes(x = date_m, y = bot_mult, linetype = "6% constraint"), linetype="dashed")  +
  geom_line(data = us_cap_2_sum,  aes(x = date_m, y = med_mult, linetype = "12% constraint"), color = "black", size = 1.2)  +
#  geom_line(data = us_cap_2_sum,  aes(x = date_m, y = top_mult, linetype = "12% constraint"), linetype="dashed")  +
#  geom_line(data = us_cap_2_sum,  aes(x = date_m, y = bot_mult, linetype = "12% constraint"), linetype="dashed")  +
  geom_line(data = us_mon_agg_covid2, aes(x = date_m, y = (m2_fix+CURRENCY)/(RESERVES+CURRENCY)), color = "black", size = 3) +
  theme_bw() + ylab("") + xlab("") + 
  scale_linetype_manual(values = c("dotted","dashed")) +
  scale_y_continuous(breaks=seq(2,8,1), limits = c(2,8.2)) +
  scale_x_date(breaks = as.Date(c("2004-01-01","2008-01-01",  "2012-01-01",  "2016-01-01",  "2020-01-01")), labels = c("2004","2008",  "2012",  "2016",  "2020"))  +
  geom_text(data=lsap_dates_covid, mapping=aes(x=end, y= 6.5, label=prog), size=4, angle=90, vjust=-0.4, hjust=0, color = "black") +
  geom_rect(data=lsap_dates_covid, mapping=aes(xmin=start, xmax=end, ymin=2, ymax=8.2), fill="grey", alpha=0.2) +
  scale_color_brewer(palette = "Set1") + scale_fill_brewer(palette = "Set1") + theme_bw()+
  theme(text = element_text(size=20)) + theme(axis.text.x = element_text(size=20)) + theme(axis.text.y = element_text(size=20)) +
  theme(legend.title = element_blank()) + theme(legend.position="bottom") + theme(legend.text=element_text(size=20)) + 
  guides(linetype = guide_legend(nrow = 3)) + theme(legend.key.width = unit(3,"cm")) 

#ggsave("Charts/F. Covid/us_cap_mult_covid.png")


dev.copy(pdf,'Charts/F. Covid/us_cap_mult_covid_bw.pdf')

dev.off()

ggplot() + 
  geom_line(data = us_cap_1_sum,  aes(x = date_m, y = med_dep/1000, linetype = "8% constraint"), color = "black", size = 1.2)  +
#  geom_line(data = us_cap_1_sum,  aes(x = date_m, y = top_dep/1000, linetype = "8% constraint"), linetype="dashed")  +
#  geom_line(data = us_cap_1_sum,  aes(x = date_m, y = bot_dep/1000, linetype = "8% constraint"), linetype="dashed")  +
  geom_line(data = us_cap_2_sum,  aes(x = date_m, y = med_dep/1000, linetype = "12% constraint"), color = "black", size = 1.2)  +
#  geom_line(data = us_cap_2_sum,  aes(x = date_m, y = top_dep/1000, linetype = "12% constraint"), linetype="dashed")  +
#  geom_line(data = us_cap_2_sum,  aes(x = date_m, y = bot_dep/1000, linetype = "12% constraint"), linetype="dashed")  +
  geom_line(data = us_mon_agg_covid2, aes(x = date_m, y = m2_fix/1000), color = "black", size = 3) +
  theme_bw() + ylab("USDbn") + xlab("") + 
  scale_linetype_manual(values = c("dotted","dashed")) +
  scale_x_date(breaks = as.Date(c("2004-01-01","2008-01-01",  "2012-01-01",  "2016-01-01",  "2020-01-01")), labels = c("2004","2008",  "2012",  "2016",  "2020"))  +
  geom_text(data=lsap_dates_covid, mapping=aes(x=end, y= 15, label=prog), size=4, angle=90, vjust=-0.4, hjust=0, color = "black") +
  geom_rect(data=lsap_dates_covid, mapping=aes(xmin=start, xmax=end, ymin=0, ymax=20), fill="grey", alpha=0.2) + 
  scale_color_brewer(palette = "Set1") + scale_fill_brewer(palette = "Set1") + theme_bw()+
  theme(text = element_text(size=20)) + theme(axis.text.x = element_text(size=20)) + theme(axis.text.y = element_text(size=20)) +
  theme(legend.title = element_blank()) + theme(legend.position="bottom") + theme(legend.text=element_text(size=20)) + 
  guides(linetype = guide_legend(nrow = 3)) + theme(legend.key.width = unit(3,"cm")) 

#ggsave("Charts/F. Covid/us_cap_dep_covid.png")


dev.copy(pdf,'Charts/F. Covid/us_cap_dep_covid_bw.pdf')

dev.off()